public class Suite_v2{

    private static int suite(int n, int u0, int u1) throws ImpossibleEvaluationException {
        if (n == 0) 
            return u0;		  
        if (n == 1)
            return u1;
        try{
            int un_1 = suite(n-1, u0, u1);
            int un_2 = suite(n-2, u0, u1);
            if (n % 2 == 0)
                return un_1/ un_2 - un_2/un_1;
            return un_2/ un_1 - un_1/un_2;
        } 
        catch(ImpossibleEvaluationException e){
            e.addTrace("\nappelé par suite (" + n +","+ u0 + ","+ u1 +")");
            throw e;
        }
        catch (ArithmeticException e){
            ImpossibleEvaluationException erreur = new ImpossibleEvaluationException("Division par 0");
            erreur.addTrace("dans suite (" + n +","+ u0 + ","+ u1 +")");
            throw erreur;
        }
    }

    private static void usage(){
        System.err.println("Usage : Suite <n> <u0> <u1>");
        System.exit(1);
    }

    public static void main(String[] args){
        if( args.length != 3)
            usage();
        try{
            int n = Integer.parseInt(args[0]);
            int u0 = Integer.parseInt(args[1]);
            int u1 = Integer.parseInt(args[2]);

            System.out.println("Suite(" + n + "," + u0 + "," + u1 + ") = " 
                    + suite(n, u0, u1));
        }
        catch (NumberFormatException e){
            System.err.println("Les arguments sont entiers");
            usage();
        }
        catch (ImpossibleEvaluationException e){
            System.err.println(e);
        }
    }
}

/*ImpossibleEvaluationException: Division par 0
[dans suite (5,3,1), 
appelé par suite (6,3,1), 
appelé par suite (7,3,1), 
appelé par suite (8,3,1), 
appelé par suite (9,3,1), 
appelé par suite (10,3,1)]
*/
